#include "dxf_create_elmt.h"

extern struct DXF_base DXF_main_base[1];
extern struct DXF_header DXF_input_header[500];
extern struct DXF_table_block_record DXF_input_table_block_record[500];

extern struct DXF_entities_arc DXF_input_entities_arc[1000];
extern struct DXF_entities_line DXF_input_entities_line[100000];
extern struct DXF_entities_attdef DXF_input_entities_attdef[1000];
extern struct DXF_entities_attrib DXF_input_entities_attrib[1000];
extern struct DXF_entities_circle DXF_input_entities_circle[1000];
extern struct DXF_entities_point DXF_input_entities_point[1000];
extern struct DXF_entities_text DXF_input_entities_text[1000];
extern struct DXF_entities_ellipse DXF_input_entities_ellipse[1000];
extern struct DXF_entities_insert DXF_input_entities_insert[1000];
extern struct DXF_entities_polyline DXF_input_entities_polyline[1000];
extern struct DXF_entities_seqend DXF_input_entities_seqend[1000];
extern struct DXF_entities_vertex DXF_input_entities_vertex[5000];
extern struct DXF_entities_lwpolyline DXF_input_entities_lwpolyline[1000];

extern struct DXF_block_line DXF_input_block_line[100][50];
extern struct DXF_block_arc DXF_input_block_arc[100][50];
extern struct DXF_block_attdef DXF_input_block_attdef[100][50];
extern struct DXF_block_attrib DXF_input_block_attrib[100][50];
extern struct DXF_block_circle DXF_input_block_circle[100][50];
extern struct DXF_block_ellipse DXF_input_block_ellipse[100][50];
extern struct DXF_block_attdef DXF_input_block_attdef[100][50];
extern struct DXF_block_attrib DXF_input_block_attrib[100][50];
extern struct DXF_block_lwpolyline DXF_input_block_lwpolyline[100][50];
extern struct DXF_block_point DXF_input_block_point[100][50];
extern struct DXF_block_polyline DXF_input_block_polyline[100][50];
extern struct DXF_block_seqend DXF_input_block_seqend[100][50];
extern struct DXF_block_text DXF_input_block_text[100][50];
extern struct DXF_block_vertex DXF_input_block_vertex[100][500];

DXF_create_elmt::DXF_create_elmt(QWidget *parent) :
	QMainWindow(parent)
{

}

 QString DXF_create_elmt::Make_ELMT()
{
	Result="";

	BaseELMT Create_ELMT;

	Count_lines=0;
	Count_header=DXF_main_base[0].dxf_header_item_count-1;
	DXF_LIMMAX=0;
	DXF_LIMMIN=0;
	DXF_LIMMAX_x=0;
	DXF_LIMMAX_y=0;
	DXF_LIMMIN_x=0;
	DXF_LIMMIN_y=0;

	while (Count_lines<Count_header)
	{

		if (DXF_input_header[Count_lines].dxf_setvar_naam=="$LIMMAX")
		{
			DXF_LIMMAX_x = DXF_input_header[Count_lines].dxf_setvar_code_10;
			DXF_LIMMAX_y = DXF_input_header[Count_lines].dxf_setvar_code_20;
			DXF_LIMMAX=1;
		}

		if (DXF_input_header[Count_lines].dxf_setvar_naam=="$LIMMIN")
		{
			DXF_LIMMIN_x = DXF_input_header[Count_lines].dxf_setvar_code_10;
			DXF_LIMMIN_y = DXF_input_header[Count_lines].dxf_setvar_code_20;
			DXF_LIMMIN=1;
		}

		if (DXF_LIMMAX==1 and DXF_LIMMIN==1)
		{
			Count_lines=Count_header+1;

		}
		else
		{
			Count_lines=Count_lines+1;
		}

	}

	if (DXF_LIMMAX==1 and DXF_LIMMIN==1)
	{
		if (DXF_LIMMAX_x<0)
		{
			DXF_LIMMAX_x= -DXF_LIMMAX_x;
		}
		if (DXF_LIMMAX_y<0)
		{
			DXF_LIMMAX_y= -DXF_LIMMAX_y;
		}
		if (DXF_LIMMIN_x<0)
		{
			DXF_LIMMIN_x= -DXF_LIMMIN_x;
		}
		if (DXF_LIMMIN_y<0)
		{
			DXF_LIMMIN_y= -DXF_LIMMIN_y;
		}

		Create_ELMT.ELMT_definition_height=QString::number(DXF_LIMMAX_x+DXF_LIMMIN_x,'f',2);
		Create_ELMT.ELMT_definition_width=QString::number(DXF_LIMMAX_y+DXF_LIMMIN_y,'f',2);

	}
	else
	{
		Create_ELMT.ELMT_definition_height="50";
		Create_ELMT.ELMT_definition_width="40";
	}

	Create_ELMT.ELMT_definition_version="0.5";
	Create_ELMT.ELMT_definition_hotspot_x="0";
	Create_ELMT.ELMT_definition_hotspot_y="0";
	Create_ELMT.ELMT_definition_link_type="master";
	Create_ELMT.ELMT_definition_type="element";
	Create_ELMT.ELMT_definition_orientation="dyyy";

	Result.append(Create_ELMT.DefinitionStart());

	Result.append(Create_ELMT.Uuid());

	Create_ELMT.ELMT_Name_text_ar=DXF_main_base[0].DXF_ELMT_Name_text_ar;
	if (Create_ELMT.ELMT_Name_text_ar != "")
	{
		Create_ELMT.ELMT_Name_ar="ar";
	}
	else
	{
		Create_ELMT.ELMT_Name_ar="-";
	}


	Create_ELMT.ELMT_Name_text_de=DXF_main_base[0].DXF_ELMT_Name_text_de;
	if (Create_ELMT.ELMT_Name_text_de != "")
	{
		Create_ELMT.ELMT_Name_de="de";
	}
	else
	{
		Create_ELMT.ELMT_Name_de="-";
	}


	Create_ELMT.ELMT_Name_text_en=DXF_main_base[0].DXF_ELMT_Name_text_en;
	if (Create_ELMT.ELMT_Name_text_en != "")
	{
		Create_ELMT.ELMT_Name_en="en";
	}
	else
	{
		Create_ELMT.ELMT_Name_en="-";
	}

	Create_ELMT.ELMT_Name_text_it=DXF_main_base[0].DXF_ELMT_Name_text_it;
	if (Create_ELMT.ELMT_Name_text_it != "")
	{
		Create_ELMT.ELMT_Name_it="it";
	}
	else
	{
		Create_ELMT.ELMT_Name_it="-";
	}

	Create_ELMT.ELMT_Name_text_fr=DXF_main_base[0].DXF_ELMT_Name_text_fr;
	if (Create_ELMT.ELMT_Name_text_fr != "")
	{
		Create_ELMT.ELMT_Name_fr="fr";
	}
	else
	{
		Create_ELMT.ELMT_Name_fr="-";
	}

	Create_ELMT.ELMT_Name_text_pl=DXF_main_base[0].DXF_ELMT_Name_text_pl;
	if (Create_ELMT.ELMT_Name_text_pl != "")
	{
		Create_ELMT.ELMT_Name_pl="pl";
	}
	else
	{
		Create_ELMT.ELMT_Name_pl="-";
	}

	Create_ELMT.ELMT_Name_text_es=DXF_main_base[0].DXF_ELMT_Name_text_es;
	if (Create_ELMT.ELMT_Name_text_es != "")
	{
		Create_ELMT.ELMT_Name_es="es";
	}
	else
	{
		Create_ELMT.ELMT_Name_es="-";
	}

	Create_ELMT.ELMT_Name_text_nl=DXF_main_base[0].DXF_ELMT_Name_text_nl;
	if (Create_ELMT.ELMT_Name_text_nl != "")
	{
		Create_ELMT.ELMT_Name_nl="nl";
	}
	else
	{
		Create_ELMT.ELMT_Name_nl="-";
	}

	Create_ELMT.ELMT_Name_text_cs=DXF_main_base[0].DXF_ELMT_Name_text_cs;
	if (Create_ELMT.ELMT_Name_text_cs != "")
	{
		Create_ELMT.ELMT_Name_cs="cs";
	}
	else
	{
		Create_ELMT.ELMT_Name_cs="-";
	}

	Create_ELMT.ELMT_Name_text_be_nl=DXF_main_base[0].DXF_ELMT_Name_text_be_nl;
	if (Create_ELMT.ELMT_Name_text_be_nl != "")
	{
		Create_ELMT.ELMT_Name_be_nl="be-nl";
	}
	else
	{
		Create_ELMT.ELMT_Name_be_nl="-";
	}

	Result.append(Create_ELMT.Names());
	//Result.append(Create_ELMT.KindInformation());
	Result.append(Create_ELMT.Informations());
	Result.append(Create_ELMT.DescriptionStart());

	Result.append(Make_input());		// basic item needed by elmt editor
	Result.append(Make_terminal());		// basic item needed by elmt editor

	/* LINE */

	Count_entitie_line=DXF_main_base[0].DXF_entities_line_count;

	Result.append(Make_LINE());

	/* ARC */

	Count_entitie_arc=DXF_main_base[0].DXF_entities_arc_count;

	Result.append(Make_ARC());

	/* ATTDEF */

	Count_entitie_attdef=DXF_main_base[0].DXF_entities_attdef_count;

	Result.append(Make_ATTDEF());

	/* ATTR */

	Count_entitie_attr=DXF_main_base[0].DXF_entities_attrib_count;

	Result.append(Make_ATTR());

	/* CIRCLE */

	Count_entitie_circle=DXF_main_base[0].DXF_entities_circle_count;

	Result.append(Make_CIRCLE());



	/* POINT */

	Count_entitie_point=DXF_main_base[0].DXF_entities_point_count;

	Result.append(Make_POINT());

	/* TEXT */

	Count_entitie_text=DXF_main_base[0].DXF_entities_text_count;
	Result.append(Make_TEXT());

	/* ELLIPSE */

	Count_entitie_ellipse=DXF_main_base[0].DXF_entities_ellipse_count;
	Result.append(Make_ELLIPSE());

	/* POLYLINE */

	Count_entitie_polyline=DXF_main_base[0].DXF_entities_polyline_count;
	Result.append(Make_POLYLINE());

	/* INSERT */

	Count_entitie_insert=DXF_main_base[0].DXF_entities_insert_count;
	Result.append(Make_INSERT());

	/* LWPOLYLINE */
	Count_entitie_lwpolyline=DXF_main_base[0].DXF_entities_lwpolyline_count;
	Result.append(Make_LWPOLYLINE());

	/* Close elmt description */

	Result.append(Create_ELMT.DescriptionEnd());
	Result.append(Create_ELMT.DefinitionEnd());

	return Result;
}

 QString DXF_create_elmt::Make_LINE()
 {

	 DXF_LINE dxb_line;

	 Result_line ="";

	 Count_lines=0;

	 while (Count_lines<=Count_entitie_line)
	 {

		dxb_line.x1=DXF_input_entities_line[Count_lines].DXF_entities_line_code_10;
		dxb_line.x2=DXF_input_entities_line[Count_lines].DXF_entities_line_code_11;
		dxb_line.y1=-DXF_input_entities_line[Count_lines].DXF_entities_line_code_20;
		dxb_line.y2=-DXF_input_entities_line[Count_lines].DXF_entities_line_code_21;
		dxb_line.ltype=DXF_input_entities_line[Count_lines].DXF_entities_line_code_6;
		dxb_line.layer=DXF_input_entities_line[Count_lines].DXF_entities_line_code_8;
		dxb_line.color="black";


		Result_line.append(dxb_line.Create_LINE());

		Count_lines=Count_lines+1;


	 }

	 return Result_line;
 }

 QString DXF_create_elmt::Make_input()
 {

	 dxf_attdef db_input;

	 Result_input="";

	 db_input.x=0;
	 db_input.y=10;
	 db_input.size=9;
	 db_input.rotate="true";
	 db_input.text="_";
	 db_input.tag="label";
	 db_input.rotation=0;

	 Result_input.append(db_input.Create_ATTDEF());

	 return Result_input;

 }

 QString DXF_create_elmt::Make_terminal()
 {

	 dxf_point db_terminal;

	 Result_terminal="";

	 db_terminal.x1=0;
	 db_terminal.y1=0;
	 db_terminal.orientation="n";

	 Result_terminal.append(db_terminal.Create_POINT());


	 return Result_terminal;

 }

 QString DXF_create_elmt::Make_ARC()
 {
	 dxf_arc db_arc;

	 Result_arc="";

	 Count_lines=0;

	 while (Count_lines<=Count_entitie_arc)
	 {

		db_arc.center_x=DXF_input_entities_arc[Count_lines].DXF_entities_arc_code_10;
		db_arc.center_y=-DXF_input_entities_arc[Count_lines].DXF_entities_arc_code_20;
		db_arc.radius=DXF_input_entities_arc[Count_lines].DXF_entities_arc_code_40;
		db_arc.start_angle=DXF_input_entities_arc[Count_lines].DXF_entities_arc_code_50;
		db_arc.end_angle=DXF_input_entities_arc[Count_lines].DXF_entities_arc_code_51;

		db_arc.layer=DXF_input_entities_arc[Count_lines].DXF_entities_arc_code_8;
		db_arc.ltype=DXF_input_entities_arc[Count_lines].DXF_entities_arc_code_6;
		db_arc.color_dxf=-1;

		Result_arc.append(db_arc.Create_ARC());

		Count_lines=Count_lines+1;


	 }


	 return Result_arc;

 }

 QString DXF_create_elmt::Make_ATTDEF()
 {

	 dxf_attdef dxb_attdef2;
	 DXF_Text_control db_txt_check;

	 Result_attdef ="";

	 Count_lines=0;

	 while (Count_lines<=Count_entitie_attdef)
	 {

		dxb_attdef2.x=DXF_input_entities_attdef[Count_lines].DXF_entities_attdef_code_10;
		dxb_attdef2.y=-DXF_input_entities_attdef[Count_lines].DXF_entities_attdef_code_20;
		dxb_attdef2.rotation=DXF_input_entities_attdef[Count_lines].DXF_entities_attdef_code_50;
		dxb_attdef2.size=DXF_input_entities_attdef[Count_lines].DXF_entities_attdef_code_40;
		dxb_attdef2.tag="label"; //DXF_input_entities_attdef[Count_lines].DXF_entities_attdef_code_2;
		dxb_attdef2.rotate="true";

		db_txt_check.TextToCheck=DXF_input_entities_attdef[Count_lines].DXF_entities_attdef_code_1;

		dxb_attdef2.text=db_txt_check.Text_control();

		Result_attdef.append(dxb_attdef2.Create_ATTDEF());

		Count_lines=Count_lines+1;


	 }

	 return Result_attdef;
 }

 QString DXF_create_elmt::Make_ATTR()
 {

	 dxf_attdef dxb_attr;
	 DXF_Text_control db_txt_check2;

	 Result_attr ="";

	 Count_lines=0;

	 while (Count_lines<=Count_entitie_attr)
	 {

		dxb_attr.x=DXF_input_entities_attrib[Count_lines].DXF_entities_attrib_code_10;					// x start
		dxb_attr.y=-DXF_input_entities_attrib[Count_lines].DXF_entities_attrib_code_20;					// y start
		dxb_attr.rotation=DXF_input_entities_attrib[Count_lines].DXF_entities_attrib_code_50;			//text rotation
		dxb_attr.size=DXF_input_entities_attrib[Count_lines].DXF_entities_attrib_code_40;				//text height
		dxb_attr.tag="label"; //DXF_input_entities_attrib[Count_lines].DXF_entities_attrib_code_2;		// tag
		dxb_attr.rotate="true";

		db_txt_check2.TextToCheck=DXF_input_entities_attrib[Count_lines].DXF_entities_attrib_code_1;	// value

		dxb_attr.text=db_txt_check2.Text_control();

		Result_attr.append(dxb_attr.Create_ATTDEF());

		Count_lines=Count_lines+1;


	 }

	 return Result_attr;

 }

 QString DXF_create_elmt::Make_CIRCLE()
{
	dxf_circle db_circle;

	Result_circle="";

	Count_lines=0;

	while (Count_lines<=Count_entitie_circle)
	{

	   db_circle.x=DXF_input_entities_circle[Count_lines].DXF_entities_circle_code_10;
	   db_circle.y=-DXF_input_entities_circle[Count_lines].DXF_entities_circle_code_20;
	   db_circle.diameter=DXF_input_entities_circle[Count_lines].DXF_entities_circle_code_40*2;


	   db_circle.layer=DXF_input_entities_circle[Count_lines].DXF_entities_circle_code_8;
	   db_circle.ltype=DXF_input_entities_circle[Count_lines].DXF_entities_circle_code_6;
	   db_circle.color="black";
	   db_circle.antialias="true";
	   db_circle.line_weight="thin";
	   db_circle.filling="none";


	   Result_circle.append(db_circle.Create_CIRCLE());

	   Count_lines=Count_lines+1;


	}


	return Result_circle;

}

 QString DXF_create_elmt::Make_POINT()
{
	Result_point="";

	dxf_point db_point;

	Count_lines=0;

	while (Count_lines<=Count_entitie_point)
	{

		db_point.x1=DXF_input_entities_point[Count_lines].DXF_entities_point_code_10;
		db_point.y1=-DXF_input_entities_point[Count_lines].DXF_entities_point_code_20;
		db_point.orientation="n";

		Result_point.append(db_point.Create_POINT());

		Count_lines=Count_lines+1;
	}

	return Result_point;
}

 QString DXF_create_elmt::Make_TEXT()
 {

	dxf_text db_text;
	DXF_Text_control db_txt_check;

	Result_text="";

	Count_lines=0;

	while (Count_lines<=Count_entitie_text)
	{

	   db_text.QET_x=DXF_input_entities_text[Count_lines].DXF_entities_text_code_10;
	   db_text.QET_y=-DXF_input_entities_text[Count_lines].DXF_entities_text_code_20;
	   db_text.QET_rotation=DXF_input_entities_text[Count_lines].DXF_entities_text_code_50;
	   db_text.QET_size=DXF_input_entities_text[Count_lines].DXF_entities_text_code_40;



	   db_txt_check.TextToCheck=DXF_input_entities_text[Count_lines].DXF_entities_text_code_1;

	   db_text.QET_text=db_txt_check.Text_control();

	   Result_text.append(db_text.Create_Text());

	   Count_lines=Count_lines+1;


	}

	return Result_text;
 }

 QString DXF_create_elmt::Make_ELLIPSE()
 {

	dxf_ellipse db_ellipse;


	Result_ellipse2="";

	Count_lines=0;

	while (Count_lines<=Count_entitie_ellipse)
	{

	   db_ellipse.center_x=DXF_input_entities_ellipse[Count_lines].DXF_entities_ellipse_code_10;
	   db_ellipse.center_y=-DXF_input_entities_ellipse[Count_lines].DXF_entities_ellipse_code_20;
	   db_ellipse.major_radius_x=DXF_input_entities_ellipse[Count_lines].DXF_entities_ellipse_code_11;
	   db_ellipse.major_radius_y=-DXF_input_entities_ellipse[Count_lines].DXF_entities_ellipse_code_21;
	   db_ellipse.ratio_of_minor=DXF_input_entities_ellipse[Count_lines].DXF_entities_ellipse_code_40;
	   db_ellipse.start=DXF_input_entities_ellipse[Count_lines].DXF_entities_ellipse_code_41;
	   db_ellipse.end2=DXF_input_entities_ellipse[Count_lines].DXF_entities_ellipse_code_42;
	   db_ellipse.LineTypeOFLine=DXF_input_entities_ellipse[Count_lines].DXF_entities_ellipse_code_6;
	   db_ellipse.LayerNameOFLine=DXF_input_entities_ellipse[Count_lines].DXF_entities_ellipse_code_8;
	   db_ellipse.Color="blue";
	   db_ellipse.Line_weight="thin";
	   db_ellipse.Filling="none";



	   Result_ellipse2.append(db_ellipse.Create_ELLIPSE());

	   Count_lines=Count_lines+1;


	}

	return Result_ellipse2;
 }

 QString DXF_create_elmt::Make_POLYLINE()
 {

	dxf_polyline db_polyline;

	Polyline_vertex=DXF_main_base[0].DXF_entities_vertex_count;

	Result_polyline="";

	Count_lines=0;
	count_vertex=1;

	while (Count_lines<Count_entitie_polyline)
	{

	   for(counter_x=0;counter_x<Polyline_vertex;counter_x++)
	   {

		   if (DXF_input_entities_vertex[counter_x].Master_handle_id==DXF_input_entities_polyline[Count_lines].DXF_entities_polyline_code_5)
		   {
			db_polyline.x_vector[count_vertex]=DXF_input_entities_vertex[counter_x].DXF_entities_vertex_code_10;
			db_polyline.y_vector[count_vertex]=-DXF_input_entities_vertex[counter_x].DXF_entities_vertex_code_20;
			count_vertex=count_vertex+1;
		   }
		   if (count_vertex>499)
		   {
			   counter_x=Polyline_vertex+1;
		   }
		   if (count_vertex>Polyline_vertex)
		   {
			   counter_x=Polyline_vertex+1;
		   }

	   }

	   db_polyline.vector_count=count_vertex-1;

	   db_polyline.antialias="false";
	   db_polyline.line_style="normal";
	   db_polyline.line_weight="thin";
	   db_polyline.filling="none";
	   db_polyline.color="magenta";
	   db_polyline.closed=DXF_input_entities_polyline[Count_lines].DXF_entities_polyline_code_70;


	   db_polyline.ltype=DXF_input_entities_polyline[Count_lines].DXF_entities_polyline_code_6;
	   db_polyline.layer=DXF_input_entities_polyline[Count_lines].DXF_entities_polyline_code_8;




	   Result_polyline.append(db_polyline.Create_POLYLINE());

	   Count_lines=Count_lines+1;
	   count_vertex=1;
	   counter_x=0;




	}

	return Result_polyline;
 }
 
 QString DXF_create_elmt::Make_LWPOLYLINE()
 {

	dxf_lwpolyline db_lwpolyline;


	Result_lwpolyline="";

	Count_lines=0;
	count_vertex=1;

	while (Count_lines<=Count_entitie_lwpolyline)
	{
		vector_max=DXF_input_entities_lwpolyline[Count_lines].DXF_entities_lwpolyline_code_90;

		if(vector_max>0)
		{
			//vector_max=vector_max+1;


	   for(counter_x=0;counter_x<vector_max;counter_x++)
	   {


			db_lwpolyline.x_vector[count_vertex]=DXF_input_entities_lwpolyline[Count_lines].DXF_entities_lwpolyline_code_10[counter_x];
			db_lwpolyline.y_vector[count_vertex]=-DXF_input_entities_lwpolyline[Count_lines].DXF_entities_lwpolyline_code_20[counter_x];
			count_vertex=count_vertex+1;

		   if (count_vertex>49)
		   {
			   counter_x=vector_max+2;
		   }
		   if (count_vertex>vector_max+1)
		   {
			   counter_x=vector_max+2;
		   }

	   }

	   db_lwpolyline.vector_count=vector_max;

	   db_lwpolyline.antialias="false";
	   db_lwpolyline.line_style="normal";
	   db_lwpolyline.line_weight="thin";
	   db_lwpolyline.filling="none";
	   db_lwpolyline.color="orange";
	   db_lwpolyline.closed=DXF_input_entities_lwpolyline[Count_lines].DXF_entities_lwpolyline_code_70;


	   db_lwpolyline.ltype=DXF_input_entities_lwpolyline[Count_lines].DXF_entities_lwpolyline_code_6;
	   db_lwpolyline.layer=DXF_input_entities_lwpolyline[Count_lines].DXF_entities_lwpolyline_code_8;




	  Result_lwpolyline.append(db_lwpolyline.Create_LWPOLYLINE());

	   Count_lines=Count_lines+1;
	   count_vertex=1;
	   counter_x=0;

		}
		else
		{
			Count_lines=Count_lines+1;
		}



	}

	return Result_lwpolyline;
 }

 QString DXF_create_elmt::Make_INSERT()
  {
	  Result_insert="";

	  Count_lines=0;

	  while (Count_lines<=Count_entitie_insert)
	  {

		if (DXF_input_entities_insert[Count_lines].DXF_entities_insert_code_2 == "")
		{
			Count_lines=Count_lines+1;

		}
		else
		{

			x_insert=0;
			y_insert=0;
			x_insert_scale=1;
			y_insert_scale=1;


			Insert_block_nr=Count_lines;

			x_insert=DXF_input_entities_insert[Count_lines].DXF_entities_insert_code_10;
			y_insert=DXF_input_entities_insert[Count_lines].DXF_entities_insert_code_20;
			x_insert_scale=DXF_input_entities_insert[Count_lines].DXF_entities_insert_code_41;
			y_insert_scale=DXF_input_entities_insert[Count_lines].DXF_entities_insert_code_42;

			xy_rotation=DXF_input_entities_insert[Count_lines].DXF_entities_insert_code_50;
			Name_insert=DXF_input_entities_insert[Count_lines].DXF_entities_insert_code_2;

			for (Block_counter=0;Block_counter<=Count_entitie_insert;Block_counter++)
			{
				if(Name_insert==DXF_input_table_block_record[Block_counter].dxf_table_block_record_code_2)
				{
					Insert_block_nr=Block_counter;
					Block_counter=Count_entitie_insert+1;
				}


			}



			/* Block LINES */

			Result_insert.append(Make_Block_LINES());

			/* Block ARC */

			Result_insert.append(Make_Block_ARC());

			/* Block CIRCLE */

			Result_insert.append(Make_Block_CIRCLE());

			/* Block ELLIPSE */

			Result_insert.append(Make_block_ELLIPSE());

			/* Block POLYLINE */

			Result_insert.append(Make_Block_POLYLINE());

			/* Block POLYLINE */

			Result_insert.append(Make_Block_LWPOLYLINE());

			/* Block ATTDEF */

			Result_insert.append(Make_Block_ATTDEF());

			/* Block ATTRIB*/

			Result_insert.append(Make_Block_ATTR());

			/* Block TEXT*/

			Result_insert.append(Make_Block_TEXT());

			/* end of block */

			Count_lines=Count_lines+1;

		}



	  }

	  return Result_insert;
  }

 QString DXF_create_elmt::Make_Block_LINES()
   {
	   Result_Block_Lines="";
	   Count_lines_block2=0;

	   DXF_LINE dxb_line;

	   while(Count_lines_block2<DXF_main_base[0].DXF_block_line_count[Insert_block_nr])
	   {


			  dxb_line.x1=x_insert+((DXF_input_block_line[Insert_block_nr][Count_lines_block2].DXF_block_line_code_10)*x_insert_scale);
			  dxb_line.x2=x_insert+((DXF_input_block_line[Insert_block_nr][Count_lines_block2].DXF_block_line_code_11)*x_insert_scale);
			  dxb_line.y1=(-y_insert)+(-(DXF_input_block_line[Insert_block_nr][Count_lines_block2].DXF_block_line_code_20*y_insert_scale));
			  dxb_line.y2=(-y_insert)+(-(DXF_input_block_line[Insert_block_nr][Count_lines_block2].DXF_block_line_code_21*y_insert_scale));
			  dxb_line.ltype=DXF_input_block_line[Insert_block_nr][Count_lines_block2].DXF_block_line_code_6;
			  dxb_line.layer=DXF_input_block_line[Insert_block_nr][Count_lines_block2].DXF_block_line_code_8;
			  dxb_line.color="red";


			Result_Block_Lines.append(dxb_line.Create_LINE());


			Count_lines_block2=Count_lines_block2+1;

	   }


	   return Result_Block_Lines;
   }

 QString DXF_create_elmt::Make_Block_ARC()
   {
	   Result_Block_Arc="";
	   Count_lines_block2=0;

	   dxf_arc dxb_arc;

	   while(Count_lines_block2<DXF_main_base[0].DXF_block_arc_count[Insert_block_nr])
	   {

		   dxb_arc.center_x=x_insert+(DXF_input_block_arc[Insert_block_nr][Count_lines_block2].DXF_block_arc_code_10*x_insert_scale);
		   dxb_arc.center_y=(-y_insert)+(-(DXF_input_block_arc[Insert_block_nr][Count_lines_block2].DXF_block_arc_code_20*y_insert_scale));
		   dxb_arc.radius=(DXF_input_block_arc[Insert_block_nr][Count_lines_block2].DXF_block_arc_code_40*x_insert_scale);

		   dxb_arc.start_angle=DXF_input_block_arc[Insert_block_nr][Count_lines_block2].DXF_block_arc_code_50;
		   dxb_arc.end_angle=DXF_input_block_arc[Insert_block_nr][Count_lines_block2].DXF_block_arc_code_51;

		   dxb_arc.layer=DXF_input_block_arc[Insert_block_nr][Count_lines_block2].DXF_block_arc_code_8;
		   dxb_arc.ltype=DXF_input_block_arc[Insert_block_nr][Count_lines_block2].DXF_block_arc_code_6;
		   dxb_arc.color_dxf=-1;
		   dxb_arc.color="red";



			Result_Block_Arc.append(dxb_arc.Create_ARC());


			Count_lines_block2=Count_lines_block2+1;

	   }


	   return Result_Block_Arc;
   }

 QString DXF_create_elmt::Make_Block_CIRCLE()
   {
	   Result_Block_Circle="";
	   Count_lines_block2=0;

	   dxf_circle dxb_circle2;

	   while(Count_lines_block2<DXF_main_base[0].DXF_block_circle_count[Insert_block_nr])
	   {

		   dxb_circle2.x=x_insert+(DXF_input_block_circle[Insert_block_nr][Count_lines_block2].DXF_block_circle_code_10*x_insert_scale);
		   dxb_circle2.y=(-y_insert)+(-(DXF_input_block_circle[Insert_block_nr][Count_lines_block2].DXF_block_circle_code_20*y_insert_scale));
		   dxb_circle2.diameter=((DXF_input_block_circle[Insert_block_nr][Count_lines_block2].DXF_block_circle_code_40*2)*x_insert_scale);

		   dxb_circle2.layer=DXF_input_block_circle[Insert_block_nr][Count_lines_block2].DXF_block_circle_code_8;
		   dxb_circle2.ltype=DXF_input_block_circle[Insert_block_nr][Count_lines_block2].DXF_block_circle_code_6;
		   dxb_circle2.color="red";
		   dxb_circle2.antialias="true";
		   dxb_circle2.line_weight="thin";
		   dxb_circle2.filling="none";



			Result_Block_Circle.append(dxb_circle2.Create_CIRCLE());


			Count_lines_block2=Count_lines_block2+1;

	   }


	   return Result_Block_Circle;
   }

 QString DXF_create_elmt::Make_block_ELLIPSE()
   {
	   Result_Block_ellipse="";
	   Count_lines_block2=0;

	   dxf_ellipse dxb_ellipse2;

	   while(Count_lines_block2<DXF_main_base[0].DXF_block_ellipse_count[Insert_block_nr])
	   {

		   dxb_ellipse2.center_x=x_insert+DXF_input_block_ellipse[Insert_block_nr][Count_lines].DXF_block_ellipse_code_10;
		   dxb_ellipse2.center_y=(-y_insert)+(-DXF_input_block_ellipse[Insert_block_nr][Count_lines].DXF_block_ellipse_code_20);
		   dxb_ellipse2.major_radius_x=DXF_input_block_ellipse[Insert_block_nr][Count_lines].DXF_block_ellipse_code_11;
		   dxb_ellipse2.major_radius_y=-DXF_input_block_ellipse[Insert_block_nr][Count_lines].DXF_block_ellipse_code_21;
		   dxb_ellipse2.ratio_of_minor=DXF_input_block_ellipse[Insert_block_nr][Count_lines].DXF_block_ellipse_code_40;
		   dxb_ellipse2.start=DXF_input_block_ellipse[Insert_block_nr][Count_lines].DXF_block_ellipse_code_41;
		   dxb_ellipse2.end2=DXF_input_block_ellipse[Insert_block_nr][Count_lines].DXF_block_ellipse_code_42;
		   dxb_ellipse2.LineTypeOFLine=DXF_input_block_ellipse[Insert_block_nr][Count_lines].DXF_block_ellipse_code_6;
		   dxb_ellipse2.LayerNameOFLine=DXF_input_block_ellipse[Insert_block_nr][Count_lines].DXF_block_ellipse_code_8;
		   dxb_ellipse2.Color="red";
		   dxb_ellipse2.Line_weight="thin";
		   dxb_ellipse2.Filling="none";


			Result_Block_ellipse.append(dxb_ellipse2.Create_ELLIPSE());


			Count_lines_block2=Count_lines_block2+1;

	   }


	   return Result_Block_ellipse;


   }

 QString DXF_create_elmt::Make_Block_POLYLINE()
   {
	   Result_Block_polyline="";
	   Count_lines_block2=0;
	   Polyline_vertex=DXF_main_base[0].DXF_block_vertex_count[Insert_block_nr];

	   dxf_polyline dxb_polyline2;

	   while(Count_lines_block2<DXF_main_base[0].DXF_block_polyline_count[Insert_block_nr])
	   {

		   Count_lines2=0;
		   count_vertex2=1;

		   Count_block_polyline=DXF_main_base[0].DXF_block_polyline_count[Insert_block_nr];

		   while (Count_lines2<=Count_block_polyline)
		   {

			  for(counter_x=0;counter_x<Polyline_vertex;counter_x++)
			  {

				  if (DXF_input_block_vertex[Insert_block_nr][counter_x].Master_block_handle_id==DXF_input_block_polyline[Insert_block_nr][Count_lines2].DXF_block_polyline_code_5)
				  {
				   dxb_polyline2.x_vector[count_vertex2]=x_insert+DXF_input_block_vertex[Insert_block_nr][counter_x].DXF_block_vertex_code_10;
				   dxb_polyline2.y_vector[count_vertex2]=(-y_insert)+(-DXF_input_block_vertex[Insert_block_nr][counter_x].DXF_block_vertex_code_20);
				   count_vertex2=count_vertex2+1;
				  }
				  if (count_vertex2>49)
				  {
					  counter_x=Polyline_vertex+1;
				  }
				  if (count_vertex2>Polyline_vertex)
				  {
					  counter_x=Polyline_vertex+1;
				  }

			  }

			  dxb_polyline2.vector_count=count_vertex;

			  dxb_polyline2.antialias="false";
			  dxb_polyline2.line_style="normal";
			  dxb_polyline2.line_weight="thin";
			  dxb_polyline2.filling="none";
			  dxb_polyline2.color="green";
			  dxb_polyline2.closed=DXF_input_block_polyline[Insert_block_nr][Count_lines2].DXF_block_polyline_code_70;


			  dxb_polyline2.ltype=DXF_input_block_polyline[Insert_block_nr][Count_lines2].DXF_block_polyline_code_6;
			  dxb_polyline2.layer=DXF_input_block_polyline[Insert_block_nr][Count_lines2].DXF_block_polyline_code_8;




			  Result_Block_polyline.append(dxb_polyline2.Create_POLYLINE());

			  Count_lines2=Count_lines2+1;
			  count_vertex2=1;
			  counter_x=0;





		   }
		   Count_lines_block2=Count_lines_block2+1;

	   }



	   return Result_Block_polyline;
   }

 QString DXF_create_elmt::Make_Block_LWPOLYLINE()
	{
		dxf_lwpolyline dxb_lwpolyline;

		Count_lines_block2=0;
		Count_lines2=0;

		Result_Block_lwpolyline="";

		while(Count_lines_block2<DXF_main_base[0].DXF_block_lwpolyline_count[Insert_block_nr])
		{


			Count_block_lwpolyline2=DXF_main_base[0].DXF_block_lwpolyline_count[Insert_block_nr];

			while (Count_lines2<Count_block_lwpolyline2)
			{
				vector_max=DXF_input_block_lwpolyline[Insert_block_nr][Count_lines2].DXF_block_lwpolyline_code_90;

				if(vector_max>0)
				{
					//vector_max=vector_max+1;


				   for(counter_x=0;counter_x<vector_max;counter_x++)
				   {


						dxb_lwpolyline.x_vector[count_vertex]=x_insert+DXF_input_block_lwpolyline[Insert_block_nr][Count_lines_block2].DXF_block_lwpolyline_code_10[counter_x];
						dxb_lwpolyline.y_vector[count_vertex]=(-y_insert)+(-DXF_input_block_lwpolyline[Insert_block_nr][Count_lines_block2].DXF_block_lwpolyline_code_20[counter_x]);
						count_vertex=count_vertex+1;

					   if (count_vertex>49)
					   {
						   counter_x=vector_max+2;
					   }
					   if (count_vertex>vector_max+1)
					   {
						   counter_x=vector_max+2;
					   }

				   }

				   dxb_lwpolyline.vector_count=vector_max;

				   dxb_lwpolyline.antialias="false";
				   dxb_lwpolyline.line_style="normal";
				   dxb_lwpolyline.line_weight="thin";
				   dxb_lwpolyline.filling="none";
				   dxb_lwpolyline.color="purple";
				   dxb_lwpolyline.closed=DXF_input_block_lwpolyline[Insert_block_nr][Count_lines_block2].DXF_block_lwpolyline_code_70;


				   dxb_lwpolyline.ltype=DXF_input_block_lwpolyline[Insert_block_nr][Count_lines_block2].DXF_block_lwpolyline_code_6;
				   dxb_lwpolyline.layer=DXF_input_block_lwpolyline[Insert_block_nr][Count_lines_block2].DXF_block_lwpolyline_code_8;




				  Result_Block_lwpolyline.append(dxb_lwpolyline.Create_LWPOLYLINE());

				   Count_lines_block2=Count_lines_block2+1;
				   count_vertex=1;
				   counter_x=0;
				   Count_lines2=Count_lines2+1;

				}
				else
				{
					Count_lines2=Count_lines2+1;
				}



			}




		}



		return Result_Block_lwpolyline;
	}

 QString DXF_create_elmt::Make_Block_ATTDEF()
 {

	 Count_lines_block2=0;
	 Result_Block_attdef="";

	 dxf_attdef dxb_attdef3;
	 DXF_Text_control db_txt_check4;


	 while(Count_lines_block2<DXF_main_base[0].DXF_block_attdef_count[Insert_block_nr])
	 {

		 dxb_attdef3.x=DXF_input_block_attdef[Insert_block_nr][Count_lines_block2].DXF_block_attdef_code_10;
		 dxb_attdef3.y=-DXF_input_block_attdef[Insert_block_nr][Count_lines_block2].DXF_block_attdef_code_20;
		 dxb_attdef3.rotation=DXF_input_block_attdef[Insert_block_nr][Count_lines_block2].DXF_block_attdef_code_50;
		 dxb_attdef3.size=DXF_input_block_attdef[Insert_block_nr][Count_lines_block2].DXF_block_attdef_code_40*((x_insert_scale+y_insert_scale)/2);
		 dxb_attdef3.tag="label"; //DXF_input_entities_attdef[Count_lines].DXF_entities_attdef_code_2;
		 dxb_attdef3.rotate="true";
		 dxb_attdef3.color_attdef="blue";

		 db_txt_check4.TextToCheck=DXF_input_block_attdef[Insert_block_nr][Count_lines_block2].DXF_block_attdef_code_1;

		 dxb_attdef3.text=db_txt_check4.Text_control();

		 Result_Block_attdef.append(dxb_attdef3.Create_ATTDEF());

		 Count_lines_block2=Count_lines_block2+1;


	 }

	 return Result_Block_attdef;
 }

 QString DXF_create_elmt::Make_Block_ATTR()
 {

	 Count_lines_block2=0;

	 Result_Block_attr="";

	 dxf_attr dxb_attr2;
	 DXF_Text_control db_txt_check3;

	 while(Count_lines_block2<DXF_main_base[0].DXF_block_attrib_count[Insert_block_nr])
	 {

		 dxb_attr2.x=DXF_input_block_attrib[Insert_block_nr][Count_lines_block2].DXF_block_attrib_code_10;					// x start
		 dxb_attr2.y=-DXF_input_block_attrib[Insert_block_nr][Count_lines_block2].DXF_block_attrib_code_20;					// y start
		 dxb_attr2.rotation=DXF_input_block_attrib[Insert_block_nr][Count_lines_block2].DXF_block_attrib_code_50;			//text rotation
		 dxb_attr2.size=DXF_input_block_attrib[Insert_block_nr][Count_lines_block2].DXF_block_attrib_code_40*((x_insert_scale+y_insert_scale)/2);				//text height
		 dxb_attr2.tag="label"; //DXF_input_entities_attrib[Count_lines].DXF_entities_attrib_code_2;		// tag
		 dxb_attr2.rotate="true";
		 dxb_attr2.color_attrib="red";

		 db_txt_check3.TextToCheck=DXF_input_block_attrib[Insert_block_nr][Count_lines].DXF_block_attrib_code_1;	// value

		 dxb_attr2.text=db_txt_check3.Text_control();

		 Result_Block_attr.append(dxb_attr2.Create_ATTR());

		 Count_lines_block2=Count_lines_block2+1;
	 }

	 return Result_Block_attr;
 }

 QString DXF_create_elmt::Make_Block_TEXT()
 {
	 Count_lines_block2=0;
	 Result_Block_Text="";

	 dxf_text db_text_block;
	 DXF_Text_control db_txt_check_block;

	while(Count_lines_block2<DXF_main_base[0].DXF_block_text_count[Insert_block_nr])
	{
		db_text_block.QET_x=DXF_input_block_text[Insert_block_nr][Count_lines_block2].DXF_block_text_code_10;
		db_text_block.QET_y=-DXF_input_block_text[Insert_block_nr][Count_lines_block2].DXF_block_text_code_20;
		db_text_block.QET_rotation=DXF_input_block_text[Insert_block_nr][Count_lines_block2].DXF_block_text_code_50;
		db_text_block.QET_size=DXF_input_block_text[Insert_block_nr][Count_lines_block2].DXF_block_text_code_40*((x_insert_scale+y_insert_scale)/2);



		db_txt_check_block.TextToCheck=DXF_input_block_text[Insert_block_nr][Count_lines_block2].DXF_block_text_code_1;

		db_text_block.QET_text=db_txt_check_block.Text_control();

		Result_Block_Text.append(db_text_block.Create_Text());

		Count_lines_block2=Count_lines_block2+1;
	}
	return Result_Block_Text;
 }
