#ifndef DXF_CREATE_ELMT_H
#define DXF_CREATE_ELMT_H

#include <QMainWindow>
#include "dxf_data.h"
#include "qet_base_types/baseelmt.h"
#include "dxftoqet_mainwindow.h"
#include "ui_dxftoqet_mainwindow.h"

#include "dxf/dxf_line.h"
#include "dxf/dxf_point.h"
#include "dxf/dxf_attdef.h"
#include "dxf/dxf_arc.h"
#include "dxf/dxf_circle.h"
#include "dxf/dxf_attr.h"
#include "dxf/dxf_text.h"
#include "dxf/dxf_ellipse.h"
#include "dxf/dxf_polyline.h"
#include "dxf/dxf_lwpolyline.h"

class DXF_create_elmt : public QMainWindow
{
	Q_OBJECT
	public:
	explicit DXF_create_elmt(QWidget *parent = 0);

	QString Make_ELMT();
	QString Make_LINE();
	QString Make_ARC();
	QString Make_input();
	QString Make_terminal();
	QString Make_ATTDEF();
	QString Make_ATTR();
	QString Make_CIRCLE();
	QString Make_POINT();
	QString Make_TEXT();
	QString Make_ELLIPSE();
	QString Make_INSERT();
	QString Make_POLYLINE();
	QString Make_LWPOLYLINE();

	QString Make_Block_LINES();
	QString Make_Block_ARC();
	QString Make_Block_ATTDEF();
	QString Make_Block_ATTR();
	QString Make_Block_CIRCLE();
	QString Make_Block_POINT();
	QString Make_block_TEXT();
	QString Make_block_ELLIPSE();
	QString Make_Block_INSERT();
	QString Make_Block_POLYLINE();
	QString Make_Block_LWPOLYLINE();
	QString Make_Block_TEXT();

	QString Result;
	QString Result_line;
	QString Result_arc;
	QString Result_input;
	QString Result_terminal;
	QString Result_attdef;
	QString Result_attr;
	QString Result_circle;
	QString Result_point;
	QString Result_text;
	QString Result_ellipse;
	QString Result_ellipse2;
	QString Result_insert;
	QString Result_polyline;
	QString Result_lwpolyline;

	QString Result_Block_Lines;
	QString Result_Block_Arc;
	QString Result_Block_attdef;
	QString Result_Block_attr;
	QString Result_Block_Circle;
	QString Result_Block_ellipse;
	QString Result_Block_polyline;
	QString Result_Block_lwpolyline;
	QString Result_Block_Text;

	double DXF_LIMMAX_x;
	double DXF_LIMMAX_y;
	double DXF_LIMMIN_x;
	double DXF_LIMMIN_y;

	bool DXF_LIMMAX;
	bool DXF_LIMMIN;

	int Count_header;
	int counter_x;
	int count_vertex;
	int vector_max;

	int count_vertex2;
	int vector_max2;
	int Count_lines2;

	int Count_block_polyline;
	int Count_block_lwpolyline2;

	int Count_entitie_line;
	int Count_entitie_arc;
	int Count_entitie_attdef;
	int Count_entitie_attr;
	int Count_entitie_circle;
	int Count_entitie_point;
	int Count_entitie_text;
	int Count_entitie_ellipse;
	int Count_entitie_insert;
	int Count_entitie_polyline;
	int Count_entitie_lwpolyline;

	int Count_lines;
	int Count_lines_block;
	int Count_lines_block2;
	int Count_for;

	int Insert_block_nr;
	int Block_counter;

	int32_t Polyline_vertex;
	int Block_Polyline_vertex;


	double x_insert;
	double y_insert;

	double x_insert_scale;
	double y_insert_scale;

	double xy_rotation;

	QString Name_insert;


	signals:

	public slots:

};

#endif // DXF_CREATE_ELMT_H
