#include "dxf_ellipse.h"

dxf_ellipse::dxf_ellipse(QWidget *parent) :
	QMainWindow(parent)
{
}

QString dxf_ellipse::Create_ELLIPSE()
{

	dxf_base_ellipse db_ellipse;

	Result_ellipse="";

	pow_major_x= (-major_radius_x);
	pow_major_y= (+major_radius_y);

	if (major_radius_x==0)
	{
		major_x=1;
	}
	else
	{
		major_radius_x=major_x;
	}

	rotation=180*((major_radius_y/major_x)/3.141592654);

	if (((qPow(pow_major_x,2) - qPow(pow_major_y,2)))<0)
	{
		width=2*(qSqrt(-(qPow(pow_major_x,2) - qPow(pow_major_y,2))));
	}
	else
	{
		width=2*(qSqrt(qPow(pow_major_x,2) - qPow(pow_major_y,2)));
	}



	//width=(qSqrt(qPow(pow_major_x,2) - qPow(pow_major_y,2)));

	height=(width*ratio_of_minor);

	Pstart=(180*(start/3.141592654));

	Pend2=(180*(end2/3.141592654));


	hoek2=Pstart-Pend2;

	db_ellipse.QET_x=center_x-(width/2);
	db_ellipse.QET_y=center_y-(height/2);
	db_ellipse.QET_start=Pstart+rotation;
	db_ellipse.QET_angle=-hoek2;
	db_ellipse.QET_width=width;
	db_ellipse.QET_height=height;
	db_ellipse.QET_antialias="false";

	DXF_Ltype_control db_line_ltype_control;

	db_line_ltype_control.FindLT=ltype;
	db_line_ltype_control.Layer=layer;


	db_ellipse.QET_line_style=db_line_ltype_control.Ltype_control();

	db_ellipse.QET_line_weight=Line_weight;
	db_ellipse.QET_filling=Filling;
	db_ellipse.QET_color=Color;



	Result_ellipse.append(db_ellipse.Create_ellipse());



	return Result_ellipse;
}


