#ifndef DXF_ELLIPSE_H
#define DXF_ELLIPSE_H

#include <QMainWindow>
#include "dxf_base_types/dxf_base_ellipse.h"
#include "dxf_control/dxf_ltype_control.h"
#include <QtMath>

class dxf_ellipse : public QMainWindow
{
	Q_OBJECT
	public:
	explicit dxf_ellipse(QWidget *parent = 0);

	QString Result_ellipse;

	int x;

	QString Lineout;
	float x_center;
	float y_center;
	float breedte;
	float hoogte;
	QString ActiveFunction;
	QString StatusbarMessage;
	QString LineTypeOFLine;
	QString LayerNameOFLine;
	QString LineStyle;
	float BeginHoek;
	float Hoek2;


	float center_x;//10
	float center_y;//20
	float major_radius_x;//11
	float major_x;
	float major_radius_y;//21
	float ratio_of_minor;//40
	float start;//41

	float end2;//42

	float width;
	float height;

	float hoek2;

	float Pstart;
	float Pend2;

	float pow_major_x;
	float pow_major_y;
	float rotation;




	QString ltype;
	QString layer;

	QString Color;
	QString Line_weight;
	QString Filling;

	QString Create_ELLIPSE();



	signals:

	public slots:

};

#endif // DXF_ELLIPSE_H
